Attribute VB_Name = "ScreenSaver"
' Fichier ScreenSaver.bas
' -----------------------

' Par Patrice Dargenton : patrice.dargenton@worldonline.fr
' http://perso.worldonline.fr/ors/index.html
' Version 1.0.4 du 3 Septembre 2001.

' Ce package contient Gravity Screen Saver et MyScreenSaver :
' ce sont deux conomiseurs d'cran (cran de veille)
' en Visual Basic 6 raliss  partir de celui cr par
' Don Bradner and Jim Deutch : JDSaver.Bas
' J'ai ajout le traitement requis pour tenir compte que dans les
' crans de veille, il y a souvent une boucle infinie qui tourne
' pour dessiner quelque chose. Lorsque l'cran de veille doit s'arrter,
' grce  la fonction DoEvents, le traitement des messages s'effectue
' malgr la boucle infinie, et le boolen bEscapeSimulation est alors mis
'  Vrai afin de quitter proprement l'application.

'- Gravity Screen Saver est un simulateur de la chaotique loi de
'  gravit qui rgit le mouvement des plantes :
'  http://perso.worldonline.fr/ors/gravity/index.html
'  http://perso.worldonline.fr/ors/gravity/gravity.zip (.scr seul, 91 Ko :
'  requiert VB6FR.DLL dans C:\Windows\System ou \System32 pour NT et XP)
'  http://perso.worldonline.fr/ors/gravity/gravitysrc.zip (sources vb6, 80 Ko)
'
' *Package d'installation avec le RunTime VB6 dont VB6FR.DLL :
'  http://perso.worldonline.fr/ors/gravity/gravityinst.zip (1.6 Mo)
'
' *Pour utiliser des images supplmentaires (space_*.jpg et star_*.bmp),
'  placez-les dans le rpertoire contenant Gravity.scr
'  (essayez, a n'a rien  voir !) :
'  http://perso.worldonline.fr/ors/gravity/morepictures.zip (2 Mo)
'  La couleur de transparence doit tre : lCouleurTransp = lCouleurVert
'  L'image de fond est affiche de faon cyclique si elle fait moins
'  de 8 cm de haut : voir rHauteurImgCycliqueMaxCm ;
'  Les images peuvent galement tre prcharges dans le formulaire FrmImages,
'  cela donne une meilleure qualit de transparence (en couleur 24 bits seulement),
'  mais cela augmente d'autant la taille du fichier .scr finale.
'  Pour faire cela, fixez la constante iNbImagesHorizBmpPicBox
'  (les plantes doivent tre au format BMP car la couleur de transparence doit
'  tre parfaite, l'image du fond peut tre au format JPG).
'  La gestion des sprites (bitmap transparent) utilise les 4 classes et mGDI.bas
'  de SP McMahon (mes modifications de ces fichiers en anglais sont en franais).
'
' *Utilisez Gravity = -1 dans les arguments de compilation conditionnelle.
'
' *1re version en C sous DOS dveloppe entre dcembre 1992 et dcembre 1994 :
'  http://perso.worldonline.fr/ors/gravity/gravitedos.zip (39 Ko)

'- MyScreenSaver est un prototype d'conomiseur d'cran minimal :
'  Il est conu pour servir de base  votre propre cran de veille !
'  http://perso.worldonline.fr/ors/gravity/myscreensaversrc.zip (20 Ko)


' Problmes restants  rsoudre (pour Gravity Screen Saver seulement) :
' -------------------------------------------------------------------
'- Instabilit des orbites : elle est due  la perte de prcision dans la simulation
'  numrique qui est une approximation des phnomnes continus de l'espace-temps ;
'  elle survient surtout lorsque deux plantes sont proches l'une de l'autre.
'- L'conomiseur ne quitte pas immdiatement, les calculs de bitmap transparent
'  ont tendance  bloquer les messages du systme, notamment les vnements
'  MouseMove permettant de quitter l'application. Parfois, la lecture simultane
'  de fichier audio est perturbe (diminuer la priorit du process principal
'  de gravity comme pour winamp ?).
'- Les bitmaps chargs  partir d'un fichier ont des petits dfauts autour de la
'  couleur de transparence : il reste des pixels verts. De plus, on est oblig de
'  diminuer leur taille (de 2.5 fois au moins) sinon la couleur de transparence
'  ne marche carrment plus du tout. Ce problme ne semble pas concerner les images
'  prcharges dans les PictureBox du formulaire FrmImages...  condition d'tre
'  en couleurs 24 bits ; en 16 bits, c'est pire et on ne peut pas diminuer la taille
'  des images  cause du tableau d'images horizontales :
'  voir PlanetesPictureBox.bmp dans morepictures.zip
'- Le mot ne passe ne marche pas sous Windows 2000... cela pour
'  aucun des crans de veille de Windows 2000 !!! (attendre SP1 ?)

' Projets :
' -------
'- Trouver une classe pour les calculs numriques en prcision ajustable : en C++,
'  il est possible de redfinir tous les oprateurs arithmtiques en prcision
'  ajustable  volont en fonction du temps et de la mmoire disponible. C'est
'  difficile, mais je connais un fou qui a essay cela !
'- Mmorisation et rappel des sessions pour faire des dmos reproductibles
'  exactement.
'- Vraie 3D avec moment d'inertie des plantes (gestion 3D des sprites),
'  le top, quoi !
'- Version Java ou vb.net pour marcher directement sur le web.
'- Simulation de chocs plantaires : j'ai essay... et chou lamentablement !
'  mais l'an dernier (2000), on m'a expliqu la dmarche  suivre :
'    En fait c'est assez facile quoique fastidieux.
'    Tu as 2 particules de masse m1 et m2 avec des vitesses v1 (v1x, v1y, v1z)
'    pour l'une et v2 (v2x, v2y, v2z) pour l'autre.
'    Tu dtermines la distance entre les 2 particules et tu t'aperois qu'elles
'    sont suffisamment proches pour rebondir.
'    1 - Tu calcules la vitesse du centre de masse : v (vx,vy,vz)
'        avec vx = (v1x * m1 + v1y * m2) / (m1 + m2), vy = ...
'    2 - Tu calcules les vitesses des 2 particules dans le centre de masse v1r et v2r
'        v1rx = v1x-vx, v1ry = v1y-vy, v1rz = v1z-vz
'        v2rx = v2x-vx, v2ry = v2y-vy, v2rz = v2z-vz
'    3 - Dans le rfrentiel li au centre de masse, la quantit de mouvement P = 0
'        - Pour que l'nergie cintique soit conserve, il faut que les vitesses
'          des particules avant et aprs le choc aient le mme module :
'          norme(v1') = norme(v1) et norme(v2') = norme(v2)
'        - Pour que les lois de la rflexion ne soient pas violes, il faut que
'          la somme des vitesses d'une particule avant et aprs le choc soit
'          parallle  l'axe passant par le centre de tes particules au moment
'          du choc : (v1+v1').(r1-r2)=0 .... le '.' est un produit scalaire.
'    Rsous les quations et tu auras v1' (v1'x, v1'y, v1'z)...   Bonne chance.


' Commentaires issus de JDSaver.Bas :
'---------------------------------------------------------------------------
'This is VB5 sample code which produces a Windows95/NT4 screen saver.  The
'program recognizes and properly deals with all of the command line parameters
'generated by the Display Options dialog, including running in the preview window
'and providing password dialogs.  The actual screen saver is a simple colored
'disk paint and is provided for demonstrations purposes.
'
'In a recent issue of Microsoft Developer Network News, in response to a question
'about what is required to produce a Windows 95 screen saver, "Dr. GUI" responds
'in part: "1. To write screensavers for Windows 95, you'll need the Win32 SDK.
'2.  Dr. GUI recommends using C++ for this task.  You'll need C++ or at least C to
'interface with Windows...."  The good doctor has presumably never seen our sample!
'
'MSGHOO32.OCX was needed in the VB4/32 version of this project,
'but with the ability to subclass using AddressOf that file is
'no longer needed.  The VB4/32 version, and MsgHoo32.ocx,
'remain available on Don's web page at arcatapet.com, below.
'
'The VB4/32 version was also distributed with a need for Comctl32.ocx,
'because it used a slider control.  That was replaced with a scroll bar
'in this version so that users with the learning version of VB5 would
'be able to load the project.
'
'1996-1997 by Don Bradner and Jim Deutch.  Freely distributable.  Originally released in
'September, 1996.  Modified October, 1996 to include code to make disable Ctrl-Alt-Del when
'password protection is enabled.  Modified January, 1997 to include code to use the Windows
'Screen Saver password routines rather than a custom one.  Also modified slightly to make
'the "configure" option work when the .SCR file is right-clicked.  Modified for VB5 in
'May, 1997.

'Don Bradner may be contacted at Compuserve 76130,1007 or
'dbirdman@arcatapet.com.  Jim Deutch may be contacted at
'Compuserve 103134,3516.
'
'No warranty is expressed or implied concerning usability or errors within this
'code.  Bug reports should be made to Don Bradner at one of the addresses above.
'
'If this program is updated, copies will normally be found in the VBPJFO and
'BASLANG forums on Compuserve, and via http://www.arcatapet.com/vb.html.
'
'Compile this program to an .scr extension in
'your Windows\System directory.  VB5 finally remembers the .scr extension
'each time the program is compiled.
'-----------------------------------------------------------------------------

Option Explicit

Type RECT 'Used by GetClientRect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Const SRCCOPY = &HCC0020
Public Const SRCAND = &H8800C6
Public Const SRCPAINT = &HEE0086
Public Const SRCINVERT = &H660046

'--------------------------------------------------------------------------
'API declarations
'--------------------------------------------------------------------------
Declare Function BitBlt& Lib "gdi32" (ByVal hDestDC&, ByVal X&, ByVal Y&, _
    ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal XSrc&, ByVal YSrc&, ByVal dwRop&)
Private Declare Function FindWindow& Lib "user32" Alias "FindWindowA" ( _
    ByVal lpClassName$, ByVal lpWindowName$)
Public Declare Function GetClientRect& Lib "user32" (ByVal hwnd&, lpRect As RECT)
Private Declare Function GetVersionEx& Lib "kernel32" Alias "GetVersionExA" ( _
    lpStruct As OsVersionInfo)

Private Declare Function PwdChangePassword& Lib "mpr" Alias "PwdChangePasswordA" ( _
    ByVal lpcRegkeyname$, ByVal hwnd&, ByVal uiReserved1&, ByVal uiReserved2&)
Private Declare Function RegCloseKey& Lib "advapi32.dll" (ByVal HKey&)
Private Declare Function RegOpenKeyExA& Lib "advapi32.dll" ( _
    ByVal HKey&, ByVal lpszSubKey$, dwOptions&, ByVal samDesired&, lpHKey&)
Private Declare Function RegQueryValueExA& Lib "advapi32.dll" ( _
    ByVal HKey&, ByVal lpszValueName$, lpdwRes&, lpdwType&, ByVal lpDataBuff$, nSize&)
Public Declare Function SetParent& Lib "user32" ( _
    ByVal hWndChild&, ByVal hWndNewParent&)

Public Declare Function SetWindowPos% Lib "user32" ( _
    ByVal h&, ByVal hb&, ByVal X&, ByVal Y&, ByVal cx&, ByVal cy&, ByVal f&)
Public Declare Function ShowCursor& Lib "user32" (ByVal bShow&)
Public Declare Function SystemParametersInfo& Lib "user32" _
    Alias "SystemParametersInfoA" (ByVal uAction&, ByVal uParam&, _
    lpvParam As Any, ByVal fuWinIni&)
Public Declare Function VerifyScreenSavePwd Lib "password.cpl" ( _
    ByVal hwnd&) As Boolean

'Registry Read permissions:
Private Const KEY_QUERY_VALUE = &H1&
Private Const KEY_ENUMERATE_SUB_KEYS = &H8&
Private Const KEY_NOTIFY = &H10&
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = READ_CONTROL
Private Const Key_Read = STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or _
    KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const REG_DWORD = 4&       ' 32-bit number
Public Const SPI_SCREENSAVERRUNNING = 97&

Type OsVersionInfo
    dwVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatform As Long
    szCSDVersion As String * 128
End Type

Public Const WM_CLOSE = &H10
Public Declare Function IsWindow& Lib "user32" (ByVal hwnd&)
Public Declare Function SetWindowLong& Lib "user32" _
    Alias "SetWindowLongA" (ByVal hwnd&, ByVal nIndex&, ByVal dwNewLong&)

'-----------------------------------------------
'Stuff used to subclass using AddressOf
Private Declare Function CallWindowProc& Lib "user32" _
    Alias "CallWindowProcA" (ByVal wndrpcPrev&, ByVal hwnd&, ByVal uMsg&, _
    ByVal wParam&, lParam As Any)
Private Const GWL_WNDPROC = -4
Private m_wndprcNext&
'-----------------------------------------------

Sub Main()
    
    Var.bQuitterApplication = False
    Var.bApercuPanneauConfig = False
    Var.iNbMouseMoves = 0
    
    'Get the user's previous preference for Circle size, with a default of half-size.
    'Size = Val(GetSetting("Samples", "JD Screen Saver", "Size", "5"))
    'Size = Val(GetSetting(sRegNomApp, sRegNomSection, sRegNomCleSize, iDefDegresRacineMax))
    'Make sure we are within allowable range.
    'If Size < 1 Then Size = 1
    'If Size > 9 Then Size = 9
    
    'We start the screen saver from a sub main which arbitrates
    'the command line parameter and loads an appropriate form.
    Dim StartType$
    StartType = UCase(Left$(Command, 2))
    If StartType = "" Then
        'This will happen when a user right-clicks the .SCR
        'file and chooses "configure"
        StartType = "/C"
    End If
    Select Case StartType
        Case "/C"
            GoSub StartScreenSaver
            FrmConfiguration.Show
        Case "/S"
            '----------------------------------------------
            'The system may start more than one screensaver
            'session, so we need to check for a previous
            'instance.  The problem is that if the previous
            'instance is a "/P" instance, the control panel
            'will not close that instance before this one
            'starts.  Therefore we can't use App.Previnstance.
            'This routine looks for the Main form and exits if
            'it is present.
            '----------------------------------------------
            If bInstanceUnique("Screen Saver Main Form") = False Then
                ' Normalement, la commande End n'est *jamais* ncessaire
                '  mais en mode dbug, on peut s'apercevoir que vb
                '  ne quitte pas toujours le prgm mme si la fct main
                '  ne lance rien. Donc voil !
                End
                'Exit Sub
            End If
            
            GoSub StartScreenSaver
            MainForm.Show
            
        Case "/P"
            Var.bApercuPanneauConfig = True
            ' Mode aperu de l'cran de veille dans la fentre windows
            '  il y a un systme pour sous-classer cette fentre de faon
            '   recevoir et traiter le msg WM_Close de l'aperu afin
            '  de fermer notre conomiseur d'cran.
            'A handle to the Preview window is passed following the
            '/p.  We will use this handle to place our output.
            Var.lHdlePreviewWnd = Val(Right$(Command, Len(Command) - 2))
            GoSub StartScreenSaver
            Load FrmControl
            
        Case "/A"
            'A handle to the Display Properties main window is passed
            'following the /a.  This handle is part of the PwdChangePassword
            'function, and places the dialog over the properties dialog.
            Var.lHdlePreviewWnd = Val(Right$(Command, Len(Command) - 2))
            Dim lRet&
            lRet = PwdChangePassword("SCRSAVE", Var.lHdlePreviewWnd, 0, 0)
  
    End Select
    
    Exit Sub
    
StartScreenSaver:
    
    Var.iScreenTwipsPerPixelX = Screen.TwipsPerPixelX
    Var.iScreenTwipsPerPixelY = Screen.TwipsPerPixelY
    
#If Gravity Then
    LireParamBaseReg
#End If
    
    ' Charger la feuille des images
    Load FrmImages

    Return
    
End Sub

Public Sub DepartDessin(objFenetre As Object, _
    pboxImgFond As PictureBox, pboxImgSprite As PictureBox)

#If Not Gravity Then
    ' pboxImgFond, pboxImgSprite ne sont pas utiliss dans ce cas :
    '  le formulaire FrmImages n'est pas utilis dans le prototype
    DessinLignes objFenetre
#Else
    If bTestEcranVeilleSimple Then
        DessinLignes objFenetre
    Else
        'Gravit
        SimulationGraviteDepart objFenetre, pboxImgFond, pboxImgSprite
    End If
#End If
    
End Sub

Private Sub DessinLignes(objFenetre As Object)
    
    ' Avec la programmation par vnements (timer, MouseMove...)
    '  il faut faire attention  la rentrance dans les fonctions
    If Var.bQuitterApplication Then Exit Sub
    If Var.bSimulationEnCours Then Exit Sub
    If Var.bEscapeSimulation Then Var.bEscapeSimulation = False: Exit Sub

    Var.bSimulationEnCours = True
    Var.bEscapeSimulation = False
    
    objFenetre.BackColor = lCouleurBleuFonce
    objFenetre.Cls
        
    While Not Var.bEscapeSimulation
        objFenetre.Line (Rnd() * objFenetre.ScaleWidth, Rnd() * objFenetre.ScaleHeight)- _
                    (Rnd() * objFenetre.ScaleWidth, Rnd() * objFenetre.ScaleHeight), _
                    Rnd() * RGB(255, 255, 255)
                    
        ' Traitement du bouton pause et des interruptions
        Do
            If Var.bEscapeSimulation Then GoTo Fin
            If Var.bRecommencerTirage Then GoTo Fin
            ' Si on ferme l'aperu de l'cran de veille :
            '  IsWindow revoit alors 0
            If Var.lHdlePreviewWnd Then
                If IsWindow(Var.lHdlePreviewWnd) = 0 Then GoTo Fin
            End If
            DoEvents
            ' Aprs un DoEvents, bEscapeSimulation peut tre mis  Vrai  un
            '  autre endroit du code (MouseMove par exemple) simultanment
            '   cette boucle, le Basic c'est fantastique !
        Loop While Var.bPauseSimulation
        
    Wend
    
Fin:
    Var.bEscapeSimulation = False
    Var.bSimulationEnCours = False
    Var.bPauseSimulation = False

End Sub

Public Sub AffichageSouris(bAfficher As Boolean)
    
    If bAfficher Then
        'Restore the mouse cursor
        Do
        Loop Until ShowCursor(bAfficher) > 5
    Else
        If bDebug Then Exit Sub
        'Make the cursor disappear
        Do
        Loop Until ShowCursor(False) < -5
    End If
    
End Sub

Private Function bInstanceUnique(FormCaption$) As Boolean
    
    'Looks for a window with the same caption
    Dim HandleWin&
    HandleWin = FindWindow(vbNullString, FormCaption)
    If HandleWin = 0 Then
        bInstanceUnique = True
    Else
        bInstanceUnique = False
    End If
    
End Function

' Suite de JDSaver.Bas :
' --------------------

Public Sub Centerform(FrmName As Form)
    FrmName.Top = Screen.Height / 2 - FrmName.Height / 2
    FrmName.Left = Screen.Width / 2 - FrmName.Width / 2
End Sub

Public Function lGetVersionWindows32&()
    Dim OsVers As OsVersionInfo
    OsVers.dwVersionInfoSize = 148&
    Dim lRet&
    lRet = GetVersionEx(OsVers)
    lGetVersionWindows32 = OsVers.dwPlatform
End Function

Public Function RegGetValue$(MainKey&, SubKey$, value$)
   ' MainKey must be one of the Publicly declared HKEY constants.
   Dim sKeyType&       'returns the key type.  This function expects REG_SZ
   Dim ret&            'returned by registry functions, should be 0&
   Dim lpHKey&         'return handle to opened key
   Dim lpcbData&       'length of data in returned string
   Dim ReturnedString$ 'returned string value
   Dim fTempDbl#
   If MainKey >= &H80000000 And MainKey <= &H80000006 Then
      ' Open key
      ret = RegOpenKeyExA(MainKey, SubKey, 0&, Key_Read, lpHKey)
      If ret <> 0 Then
         RegGetValue = ""
         Exit Function     'No key open, so leave
      End If
      
      ' Set up buffer for data to be returned in.
      ' Adjust next value for larger buffers.
      lpcbData = 255
      ReturnedString = Space$(lpcbData)

      ' Read key
      ret& = RegQueryValueExA(lpHKey, value, ByVal 0&, sKeyType, _
          ReturnedString, lpcbData)
      If ret <> 0 Then
         RegGetValue = ""   'Key still open, so finish up
      Else
        If sKeyType = REG_DWORD Then
            fTempDbl = Asc(Mid$(ReturnedString, 1, 1)) + _
                &H100& * Asc(Mid$(ReturnedString, 2, 1)) + _
                &H10000 * Asc(Mid$(ReturnedString, 3, 1)) + _
                &H1000000 * CDbl(Asc(Mid$(ReturnedString, 4, 1)))
            ReturnedString = Format$(fTempDbl, "000")
        End If
        RegGetValue = Left$(ReturnedString, lpcbData - 1)
    End If
      ' Always close opened keys!
      ret = RegCloseKey(lpHKey)
   End If
End Function

Public Function CtlProc&(ByVal hwnd&, ByVal MsgVal&, ByVal wParam&, ByVal lParam&)
    
    ' Traitement du message WM_CLOSE de la fentre parent : aperu de
    '  l'cran de veille
    
    'Example of a subclassed window using AddressOf.  Look at the
    'SubClass and UnSubClass functions to see how it is invoked.
    'Respond to the WM_CLOSE message sent to the picture box
    'when the Display Properties dialog has gone on to something
    'else or has gone away.
    If m_wndprcNext = 0 Then
        Exit Function  'This function may trigger after the window has gone away.
    End If
    Select Case MsgVal
        Case WM_CLOSE
            'Putting the picture box back where it started may not
            'be absolutely necessary, but it is good coding practice
            Dim lRet&
            lRet = SetParent(FrmControl.ImgApercu.hwnd, FrmControl.hwnd)
            
            ' On indique que la simulation doit quitter.
            '  l'application sera ferme  la fin de la simulation
            '  dans la fonction Timer1_Timer (FrmControl seulement)
            Var.bEscapeSimulation = True
            
            'Windows expects a zero return from any window processing a
            'WM_CLOSE message.
            CtlProc = 0
            Exit Function
    End Select
    'Pass all messages, except WM_CLOSE, back to the picture box's
    'default message handler
    CtlProc = CallWindowProc(m_wndprcNext, hwnd, MsgVal, wParam, ByVal lParam)
    
End Function

Public Sub subclass(hwnd&)
    m_wndprcNext = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf CtlProc)
End Sub

Public Sub UnSubClass(hWndCur&)
    If m_wndprcNext Then
        SetWindowLong hWndCur, GWL_WNDPROC, m_wndprcNext
        m_wndprcNext = 0
    End If
End Sub
